function ft817_readrxfrq (sock1)
%%% read the RX frequency and mode
msg='xxxxx';
msg(1)=0x00;
msg(2)=0x00;
msg(3)=0x00;
msg(4)=0x00;
msg(5)=0x03;
rc=send(sock1,msg);
%sleep(0.1);
[rxfreq,rxlength]=recv(sock1,5);
%fprintf('Freq: %02x%02x%02x.%02x kHz\n\r',rxfreq(1),rxfreq(2),rxfreq(3),rxfreq(4));

%%%calculate decimal representation of the frequency
freq = 1000000*double(bitand(rxfreq(1),0xf0)/(2^4)*10 + bitand(rxfreq(1),0x0f));
freq += 10000*double(bitand(rxfreq(2),0xf0)/(2^4)*10 + bitand(rxfreq(2),0x0f));
freq += 100*double(bitand(rxfreq(3),0xf0)/(2^4)*10 + bitand(rxfreq(3),0x0f));
freq += double(bitand(rxfreq(4),0xf0)/(2^4)*10 + bitand(rxfreq(4),0x0f));
freq = freq*10 %frequency in Hz (although resolution is 10Hz only)

%%%find out the modulation mode
%rxfreq
modedec=bitand(rxfreq(5),0x0F); %MSB contains narrow/wide indicator
switch (modedec)
  case 0x00
    modestr='LSB'
  case 0x01
    modestr='USB'
  case 0x02
    modestr='CW'
  case 0x03
    modestr='CWR'
  case 0x04
    modestr='AM'
  case 0x05
    modestr='invalid'
  case 0x06
    modestr='WFM'
  case 0x07
    modestr='invalid'
  case 0x08
    modestr='FM'
  case 0x09
    modestr='invalid'
  case 0x0A
    modestr='DIG'
  case 0x0B
    modestr='invalid'
  case 0x0C
    modestr='PKT'
  otherwise
    modestr='invalid'
endswitch

%%%determine which filter is used
if(bitand(rxfreq(5),0x80))
  filter='narrow'
else
  filter='normal'
endif

endfunction